=begin
#Blog Post endpoints

#\"Use these endpoints for interacting with Blog Posts, Blog Authors, and Blog Tags\"

The version of the OpenAPI document: v3

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module Hubspot
  module Cms
    module Blogs
      module Authors
        class BlogAuthor
          # The unique ID of the Blog Author.
          attr_accessor :id

          # Email address of the Blog Author.
          attr_accessor :email

          # A short biography of the blog author.
          attr_accessor :bio

          # URL to the website of the Blog Author.
          attr_accessor :website

          # URL or username of the Twitter account associated with the Blog Author. This will be normalized into the Twitter url for said user.
          attr_accessor :twitter

          # URL to the Blog Author's Facebook page.
          attr_accessor :facebook

          # URL to the blog author's LinkedIn page.
          attr_accessor :linkedin

          # URL to the blog author's avatar, if supplying a custom one.
          attr_accessor :avatar

          # The full name of the Blog Author to be displayed.
          attr_accessor :display_name

          # The timestamp (ISO8601 format) when this Blog Author was deleted.
          attr_accessor :deleted_at

          # The timestamp (ISO8601 format) when this Blog Author was created.
          attr_accessor :created_at

          # The timestamp (ISO8601 format) when this Blog Author was last updated.
          attr_accessor :updated_at

          # Attribute mapping from ruby-style variable name to JSON key.
          def self.attribute_map
            {
              :'id' => :'id',
              :'email' => :'email',
              :'bio' => :'bio',
              :'website' => :'website',
              :'twitter' => :'twitter',
              :'facebook' => :'facebook',
              :'linkedin' => :'linkedin',
              :'avatar' => :'avatar',
              :'display_name' => :'displayName',
              :'deleted_at' => :'deletedAt',
              :'created_at' => :'createdAt',
              :'updated_at' => :'updatedAt'
            }
          end

          # Attribute type mapping.
          def self.openapi_types
            {
              :'id' => :'String',
              :'email' => :'String',
              :'bio' => :'String',
              :'website' => :'String',
              :'twitter' => :'String',
              :'facebook' => :'String',
              :'linkedin' => :'String',
              :'avatar' => :'String',
              :'display_name' => :'String',
              :'deleted_at' => :'DateTime',
              :'created_at' => :'DateTime',
              :'updated_at' => :'DateTime'
            }
          end

          # List of attributes with nullable: true
          def self.openapi_nullable
            Set.new([
            ])
          end

          # Initializes the object
          # @param [Hash] attributes Model attributes in the form of hash
          def initialize(attributes = {})
            if (!attributes.is_a?(Hash))
              fail ArgumentError, "The input argument (attributes) must be a hash in `Hubspot::Cms::Blogs::Authors::BlogAuthor` initialize method"
            end

            # check to see if the attribute exists and convert string to symbol for hash key
            attributes = attributes.each_with_object({}) { |(k, v), h|
              if (!self.class.attribute_map.key?(k.to_sym))
                fail ArgumentError, "`#{k}` is not a valid attribute in `Hubspot::Cms::Blogs::Authors::BlogAuthor`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
              end
              h[k.to_sym] = v
            }

            if attributes.key?(:'id')
              self.id = attributes[:'id']
            end

            if attributes.key?(:'email')
              self.email = attributes[:'email']
            end

            if attributes.key?(:'bio')
              self.bio = attributes[:'bio']
            end

            if attributes.key?(:'website')
              self.website = attributes[:'website']
            end

            if attributes.key?(:'twitter')
              self.twitter = attributes[:'twitter']
            end

            if attributes.key?(:'facebook')
              self.facebook = attributes[:'facebook']
            end

            if attributes.key?(:'linkedin')
              self.linkedin = attributes[:'linkedin']
            end

            if attributes.key?(:'avatar')
              self.avatar = attributes[:'avatar']
            end

            if attributes.key?(:'display_name')
              self.display_name = attributes[:'display_name']
            end

            if attributes.key?(:'deleted_at')
              self.deleted_at = attributes[:'deleted_at']
            end

            if attributes.key?(:'created_at')
              self.created_at = attributes[:'created_at']
            end

            if attributes.key?(:'updated_at')
              self.updated_at = attributes[:'updated_at']
            end
          end

          # Show invalid properties with the reasons. Usually used together with valid?
          # @return Array for valid properties with the reasons
          def list_invalid_properties
            invalid_properties = Array.new
            if @id.nil?
              invalid_properties.push('invalid value for "id", id cannot be nil.')
            end

            if @email.nil?
              invalid_properties.push('invalid value for "email", email cannot be nil.')
            end

            if @bio.nil?
              invalid_properties.push('invalid value for "bio", bio cannot be nil.')
            end

            if @website.nil?
              invalid_properties.push('invalid value for "website", website cannot be nil.')
            end

            if @twitter.nil?
              invalid_properties.push('invalid value for "twitter", twitter cannot be nil.')
            end

            if @facebook.nil?
              invalid_properties.push('invalid value for "facebook", facebook cannot be nil.')
            end

            if @linkedin.nil?
              invalid_properties.push('invalid value for "linkedin", linkedin cannot be nil.')
            end

            if @avatar.nil?
              invalid_properties.push('invalid value for "avatar", avatar cannot be nil.')
            end

            if @display_name.nil?
              invalid_properties.push('invalid value for "display_name", display_name cannot be nil.')
            end

            if @deleted_at.nil?
              invalid_properties.push('invalid value for "deleted_at", deleted_at cannot be nil.')
            end

            if @created_at.nil?
              invalid_properties.push('invalid value for "created_at", created_at cannot be nil.')
            end

            if @updated_at.nil?
              invalid_properties.push('invalid value for "updated_at", updated_at cannot be nil.')
            end

            invalid_properties
          end

          # Check to see if the all the properties in the model are valid
          # @return true if the model is valid
          def valid?
            return false if @id.nil?
            return false if @email.nil?
            return false if @bio.nil?
            return false if @website.nil?
            return false if @twitter.nil?
            return false if @facebook.nil?
            return false if @linkedin.nil?
            return false if @avatar.nil?
            return false if @display_name.nil?
            return false if @deleted_at.nil?
            return false if @created_at.nil?
            return false if @updated_at.nil?
            true
          end

          # Checks equality by comparing each attribute.
          # @param [Object] Object to be compared
          def ==(o)
            return true if self.equal?(o)
            self.class == o.class &&
                id == o.id &&
                email == o.email &&
                bio == o.bio &&
                website == o.website &&
                twitter == o.twitter &&
                facebook == o.facebook &&
                linkedin == o.linkedin &&
                avatar == o.avatar &&
                display_name == o.display_name &&
                deleted_at == o.deleted_at &&
                created_at == o.created_at &&
                updated_at == o.updated_at
          end

          # @see the `==` method
          # @param [Object] Object to be compared
          def eql?(o)
            self == o
          end

          # Calculates hash code according to all attributes.
          # @return [Integer] Hash code
          def hash
            [id, email, bio, website, twitter, facebook, linkedin, avatar, display_name, deleted_at, created_at, updated_at].hash
          end

          # Builds the object from hash
          # @param [Hash] attributes Model attributes in the form of hash
          # @return [Object] Returns the model itself
          def self.build_from_hash(attributes)
            new.build_from_hash(attributes)
          end

          # Builds the object from hash
          # @param [Hash] attributes Model attributes in the form of hash
          # @return [Object] Returns the model itself
          def build_from_hash(attributes)
            return nil unless attributes.is_a?(Hash)
            self.class.openapi_types.each_pair do |key, type|
              if type =~ /\AArray<(.*)>/i
                # check to ensure the input is an array given that the attribute
                # is documented as an array but the input is not
                if attributes[self.class.attribute_map[key]].is_a?(Array)
                  self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
                end
              elsif !attributes[self.class.attribute_map[key]].nil?
                self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
              end # or else data not found in attributes(hash), not an issue as the data can be optional
            end

            self
          end

          # Deserializes the data based on type
          # @param string type Data type
          # @param string value Value to be deserialized
          # @return [Object] Deserialized data
          def _deserialize(type, value)
            case type.to_sym
            when :DateTime
              DateTime.parse(value)
            when :Date
              Date.parse(value)
            when :String
              value.to_s
            when :Integer
              value.to_i
            when :Float
              value.to_f
            when :Boolean
              if value.to_s =~ /\A(true|t|yes|y|1)\z/i
                true
              else
                false
              end
            when :Object
              # generic object (usually a Hash), return directly
              value
            when /\AArray<(?<inner_type>.+)>\z/
              inner_type = Regexp.last_match[:inner_type]
              value.map { |v| _deserialize(inner_type, v) }
            when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
              k_type = Regexp.last_match[:k_type]
              v_type = Regexp.last_match[:v_type]
              {}.tap do |hash|
                value.each do |k, v|
                  hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
                end
              end
            else # model
              Hubspot::Cms::Blogs::Authors.const_get(type).build_from_hash(value)
            end
          end

          # Returns the string representation of the object
          # @return [String] String presentation of the object
          def to_s
            to_hash.to_s
          end

          # to_body is an alias to to_hash (backward compatibility)
          # @return [Hash] Returns the object in the form of hash
          def to_body
            to_hash
          end

          # Returns the object in the form of hash
          # @return [Hash] Returns the object in the form of hash
          def to_hash
            hash = {}
            self.class.attribute_map.each_pair do |attr, param|
              value = self.send(attr)
              if value.nil?
                is_nullable = self.class.openapi_nullable.include?(attr)
                next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
              end
              
              hash[param] = _to_hash(value)
            end
            hash
          end

          # Outputs non-array value in the form of hash
          # For object, use to_hash. Otherwise, just return the value
          # @param [Object] value Any valid value
          # @return [Hash] Returns the value in the form of hash
          def _to_hash(value)
            if value.is_a?(Array)
              value.compact.map { |v| _to_hash(v) }
            elsif value.is_a?(Hash)
              {}.tap do |hash|
                value.each { |k, v| hash[k] = _to_hash(v) }
              end
            elsif value.respond_to? :to_hash
              value.to_hash
            else
              value
            end
          end
        end
      end
    end
  end
end
