=begin
#CRM cards

#Allows an app to extend the CRM UI by surfacing custom cards in the sidebar of record pages. These cards are defined up-front as part of app configuration, then populated by external data fetch requests when the record page is accessed by a user.

The version of the OpenAPI document: v3

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module Hubspot
  module Crm
    module Extensions
      module Cards
        class Error
          # A human readable message describing the error along with remediation steps where appropriate
          attr_accessor :message

          # A unique identifier for the request. Include this value with any error reports or support tickets
          attr_accessor :correlation_id

          # The error category
          attr_accessor :category

          # A specific category that contains more specific detail about the error
          attr_accessor :sub_category

          # further information about the error
          attr_accessor :errors

          # Context about the error condition
          attr_accessor :context

          # A map of link names to associated URIs containing documentation about the error or recommended remediation steps
          attr_accessor :links

          # Attribute mapping from ruby-style variable name to JSON key.
          def self.attribute_map
            {
              :'message' => :'message',
              :'correlation_id' => :'correlationId',
              :'category' => :'category',
              :'sub_category' => :'subCategory',
              :'errors' => :'errors',
              :'context' => :'context',
              :'links' => :'links'
            }
          end

          # Attribute type mapping.
          def self.openapi_types
            {
              :'message' => :'String',
              :'correlation_id' => :'String',
              :'category' => :'String',
              :'sub_category' => :'String',
              :'errors' => :'Array<ErrorDetail>',
              :'context' => :'Hash<String, Array<String>>',
              :'links' => :'Hash<String, String>'
            }
          end

          # List of attributes with nullable: true
          def self.openapi_nullable
            Set.new([
            ])
          end

          # Initializes the object
          # @param [Hash] attributes Model attributes in the form of hash
          def initialize(attributes = {})
            if (!attributes.is_a?(Hash))
              fail ArgumentError, "The input argument (attributes) must be a hash in `Hubspot::Crm::Extensions::Cards::Error` initialize method"
            end

            # check to see if the attribute exists and convert string to symbol for hash key
            attributes = attributes.each_with_object({}) { |(k, v), h|
              if (!self.class.attribute_map.key?(k.to_sym))
                fail ArgumentError, "`#{k}` is not a valid attribute in `Hubspot::Crm::Extensions::Cards::Error`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
              end
              h[k.to_sym] = v
            }

            if attributes.key?(:'message')
              self.message = attributes[:'message']
            end

            if attributes.key?(:'correlation_id')
              self.correlation_id = attributes[:'correlation_id']
            end

            if attributes.key?(:'category')
              self.category = attributes[:'category']
            end

            if attributes.key?(:'sub_category')
              self.sub_category = attributes[:'sub_category']
            end

            if attributes.key?(:'errors')
              if (value = attributes[:'errors']).is_a?(Array)
                self.errors = value
              end
            end

            if attributes.key?(:'context')
              if (value = attributes[:'context']).is_a?(Hash)
                self.context = value
              end
            end

            if attributes.key?(:'links')
              if (value = attributes[:'links']).is_a?(Hash)
                self.links = value
              end
            end
          end

          # Show invalid properties with the reasons. Usually used together with valid?
          # @return Array for valid properties with the reasons
          def list_invalid_properties
            invalid_properties = Array.new
            if @message.nil?
              invalid_properties.push('invalid value for "message", message cannot be nil.')
            end

            if @correlation_id.nil?
              invalid_properties.push('invalid value for "correlation_id", correlation_id cannot be nil.')
            end

            if @category.nil?
              invalid_properties.push('invalid value for "category", category cannot be nil.')
            end

            invalid_properties
          end

          # Check to see if the all the properties in the model are valid
          # @return true if the model is valid
          def valid?
            return false if @message.nil?
            return false if @correlation_id.nil?
            return false if @category.nil?
            true
          end

          # Checks equality by comparing each attribute.
          # @param [Object] Object to be compared
          def ==(o)
            return true if self.equal?(o)
            self.class == o.class &&
                message == o.message &&
                correlation_id == o.correlation_id &&
                category == o.category &&
                sub_category == o.sub_category &&
                errors == o.errors &&
                context == o.context &&
                links == o.links
          end

          # @see the `==` method
          # @param [Object] Object to be compared
          def eql?(o)
            self == o
          end

          # Calculates hash code according to all attributes.
          # @return [Integer] Hash code
          def hash
            [message, correlation_id, category, sub_category, errors, context, links].hash
          end

          # Builds the object from hash
          # @param [Hash] attributes Model attributes in the form of hash
          # @return [Object] Returns the model itself
          def self.build_from_hash(attributes)
            new.build_from_hash(attributes)
          end

          # Builds the object from hash
          # @param [Hash] attributes Model attributes in the form of hash
          # @return [Object] Returns the model itself
          def build_from_hash(attributes)
            return nil unless attributes.is_a?(Hash)
            self.class.openapi_types.each_pair do |key, type|
              if type =~ /\AArray<(.*)>/i
                # check to ensure the input is an array given that the attribute
                # is documented as an array but the input is not
                if attributes[self.class.attribute_map[key]].is_a?(Array)
                  self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
                end
              elsif !attributes[self.class.attribute_map[key]].nil?
                self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
              end # or else data not found in attributes(hash), not an issue as the data can be optional
            end

            self
          end

          # Deserializes the data based on type
          # @param string type Data type
          # @param string value Value to be deserialized
          # @return [Object] Deserialized data
          def _deserialize(type, value)
            case type.to_sym
            when :DateTime
              DateTime.parse(value)
            when :Date
              Date.parse(value)
            when :String
              value.to_s
            when :Integer
              value.to_i
            when :Float
              value.to_f
            when :Boolean
              if value.to_s =~ /\A(true|t|yes|y|1)\z/i
                true
              else
                false
              end
            when :Object
              # generic object (usually a Hash), return directly
              value
            when /\AArray<(?<inner_type>.+)>\z/
              inner_type = Regexp.last_match[:inner_type]
              value.map { |v| _deserialize(inner_type, v) }
            when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
              k_type = Regexp.last_match[:k_type]
              v_type = Regexp.last_match[:v_type]
              {}.tap do |hash|
                value.each do |k, v|
                  hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
                end
              end
            else # model
              Hubspot::Crm::Extensions::Cards.const_get(type).build_from_hash(value)
            end
          end

          # Returns the string representation of the object
          # @return [String] String presentation of the object
          def to_s
            to_hash.to_s
          end

          # to_body is an alias to to_hash (backward compatibility)
          # @return [Hash] Returns the object in the form of hash
          def to_body
            to_hash
          end

          # Returns the object in the form of hash
          # @return [Hash] Returns the object in the form of hash
          def to_hash
            hash = {}
            self.class.attribute_map.each_pair do |attr, param|
              value = self.send(attr)
              if value.nil?
                is_nullable = self.class.openapi_nullable.include?(attr)
                next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
              end
              
              hash[param] = _to_hash(value)
            end
            hash
          end

          # Outputs non-array value in the form of hash
          # For object, use to_hash. Otherwise, just return the value
          # @param [Object] value Any valid value
          # @return [Hash] Returns the value in the form of hash
          def _to_hash(value)
            if value.is_a?(Array)
              value.compact.map { |v| _to_hash(v) }
            elsif value.is_a?(Hash)
              {}.tap do |hash|
                value.each { |k, v| hash[k] = _to_hash(v) }
              end
            elsif value.respond_to? :to_hash
              value.to_hash
            else
              value
            end
          end
        end
      end
    end
  end
end
